<?php
/*
===================================================================
 DataLife Engine Forum v2.3 Full English By Arash.N
-------------------------------------------------------------------
 http://SyarashTools.com/
-------------------------------------------------------------------
 Pack By: http://English.DatalifeCMS.ir/
-------------------------------------------------------------------
 Copyright (C) 2006,2009 DatalifeCMS (http://DatalifeCms.iR/)
===================================================================
*/
@session_start();
@error_reporting(7);
@ini_set('display_errors', true);
@ini_set('html_errors', false);

define('DATALIFEENGINE', true);
define('ROOT_DIR', '../../..');
define('ENGINE_DIR', ROOT_DIR.'/engine');

include ENGINE_DIR.'/data/config.php';
require_once ENGINE_DIR.'/classes/mysql.php';
require_once ENGINE_DIR.'/data/dbconfig.php';

require_once ENGINE_DIR.'/data/forum_config.php';

require_once ENGINE_DIR.'/forum/sources/components/functions.php';

$_TIME = time();

if ($_COOKIE['dle_skin']) {
	if (@is_dir(ROOT_DIR.'/templates/'.$_COOKIE['dle_skin']))
		{
			$config['skin'] = $_COOKIE['dle_skin'];
		}
}

if ($config["lang_".$config['skin']]) { 

     include_once ROOT_DIR.'/language/'.$config["lang_".$config['skin']].'/website.lng';

} else {

     include_once ROOT_DIR.'/language/'.$config['langs'].'/website.lng';

}

$config['charset'] = ($lang['charset'] != '') ? $lang['charset'] : $config['charset'];

require_once ENGINE_DIR.'/modules/functions.php';
require_once ENGINE_DIR.'/modules/sitelogin.php';

if (!function_exists('convert_unicode'))
{
	function convert_unicode($t, $to = 'windows-1251')
	{
		$to = strtolower($to);

		if ($to == 'utf-8') {

			return urldecode($t);

		} else {

			if( function_exists("get_magic_quotes_gpc") && get_magic_quotes_gpc() ) $t = stripslashes( $t );

			if ( function_exists('iconv') ) $t = iconv("UTF-8", $to."//IGNORE", $t);
			else $t = "The library iconv is not supported by your server";


		}

		return urldecode($t);
	}
}

if (!$is_logged) die ("error");

$id = intval($_REQUEST['id']);

if (!$id) die ("error");

//#################   
$user_group = get_vars ("usergroup");

if (!$user_group) {
  $user_group = array ();

  $db->query("SELECT * FROM " . USERPREFIX . "_usergroups ORDER BY id ASC");

  while($row = $db->get_row()){

   $user_group[$row['id']] = array ();

     foreach ($row as $key => $value)
     {
       $user_group[$row['id']][$key] = $value;
     }

  }
  set_vars ("usergroup", $user_group);
  $db->free();
}

include_once ENGINE_DIR.'/forum/classes/parse.class.php';

$parse = new ForumParse(Array(), Array(), 1, 1);

$parse->filter_mode = group_value('filter');

if (!group_value('html')) $parse->safe_mode = true;

// ********************************************************************************
// EDIT POST
// ********************************************************************************
if ($_REQUEST['action'] == "edit")
{
	$row = $db->super_query("SELECT * FROM " . PREFIX . "_forum_posts WHERE `pid` = '$id'");
	
	if ($id != $row['pid']) die ("error");
	
	$topic_id = $row['topic_id'];
	
	$upload_var = array('area'=>"post", 'forum_id'=>$forum_id, 'topic_id'=>$topic_id, 'post_id'=>$id);
	
	$ajax_post_id = $id;
	
	$upload_var['reply'] = "reply";
	
	if (!$row['wysiwyg'])
	{
		$post_text = $parse->decodeBBCodes($row['post_text'], false);
		
		$upload_var['bb_width'] = '99%';
		
		include_once ENGINE_DIR.'/forum/sources/components/bbcode.php';
		
		$bb_code = str_replace ("{THEME}", $config['http_home_url']."templates/".$config['skin'], $bb_code);
	}
	
	else
	{
		$post_text = $parse->decodeBBCodes($row['post_text'], TRUE, "yes");
		
		include_once ENGINE_DIR.'/forum/sources/components/wysiwyg.php';
		
		$bb_code = $wysiwyg;
	}
	
	$buffer = <<<HTML
	<form method="post" name="forum_post_form_{$id}" id="forum_post_form_{$id}" action="">
	<div>{$bb_code}</div>
	<textarea id="forum_post_{$id}" name="forum_post_{$id}" onclick="setNewField(this.name, document.forum_post_form_{$id})" style="width:99%; height:150px;font-family:Tahoma; font-size:11px; border:1px solid #E0E0E0">{$post_text}</textarea><br>
	<div align="right" style="width:99%;"><input class=bbcodes title="$lang[bb_t_apply]" type=button onclick="ajax_save_post_edit('{$id}', '{$row['wysiwyg']}'); return false;" value="$lang[bb_b_apply]">
	<input class=bbcodes title="$lang[bb_t_cancel]" type=button onclick="ajax_cancel_post_edit('{$id}'); return false;" value="$lang[bb_b_cancel]">
	</div>
	</form>
HTML;
}

// ********************************************************************************
// SAVE POST
// ********************************************************************************
elseif ($_REQUEST['action'] == "save")
{
	$post_text = addslashes(convert_unicode($_POST['post_text'], $config['charset']));
	
	$wysiwyg = intval($_REQUEST['wysiwyg']);
	
	if (!$wysiwyg)
	{
		$post_text = $parse->process($post_text);
		
		$post_text = $db->safesql($parse->BB_Parse($post_text, FALSE));
	}
	
	else
	{
		if (group_value('html')) $post_text = $parse->process($post_text);
		
		$post_text = $db->safesql($parse->BB_Parse($post_text));
	}
	
	$post_text = trim($post_text);
	
	if (!$post_text) die ("error");
	
	$post_text = auto_wrap ($post_text);
	
	if (strlen($post_text) > $forum_config['post_maxlen'])
	{
		die ("<script language=\"JavaScript\" type=\"text/javascript\">\n alert ('The length of the message exceeds the limit!');\n </script>");
	}
	
	$edit_info = ", edit_user = '{$member_id[name]}', edit_time = '{$_TIME}'";
	
	$db->query("UPDATE " . PREFIX . "_forum_posts SET post_text = '$post_text' {$edit_info} WHERE pid ='$id'");
	
	$post_text = preg_replace ("'\[hide\](.*?)\[/hide\]'si","\\1", $post_text);
	
	check_attachment($pid, $post_text);
	
	if (stristr ($post_text, "[attachment="))
	{
		$row = $db->super_query("SELECT * FROM " . PREFIX . "_forum_posts WHERE `pid` = '$id'");
		
		$tid = $row['topic_id'];
		
		$ajax_edit_attach = TRUE;
		
		require_once ENGINE_DIR.'/forum/sources/components/attachment.php';
	}
	
	$buffer = stripslashes($post_text);
}

else die ("error");

@header("Content-type: text/css; charset=".$config['charset']);
echo $buffer;
?>