<?php
error_reporting(E_ALL);
/**********************************
vxWhois v1.1.0
Copyright 2004 Nick Trew.
Last Updated: 2005-01-06.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

***********************************/

/* formExtension Function */
function formExtensions (){
    global $config;
    /* Show previous selection */
    foreach ($config['domain']['extensions'] as $tld){
        echo '<option value="'.$tld.'">'.$tld.'</option>';
    }
}

/* Show Last Domain */
function showPrevious (){
   if (isset($_POST['domainForm'])){
       echo $_POST['domainForm'];
   }
}

/* Write to whois.log file. */
function whoisLog ($domain){
    global $message, $config;
    if (@is_writable($config['domain']['whois_log_location'])){
    if (!$fp = @fopen($config['domain']['whois_log_location'], 'a')){
        echo $message['error']['open_log_file'];
    }
    @fwrite($fp, date('Y-m-d @ H:i:s').' - '.$domain."\r\n");
    @fclose($fp);
    } else {
        echo $message['error']['perms_log_file'];
    }
}

function domainResults (){
    /* Declare Global Variables */
    global $config, $message;
if (isset($_POST['submitForm']) && $_POST['submitForm'] == 'Check'){

    /* Check Domain Length, etc. */
    if (strlen($_POST['domainForm']) < 3){
        echo $message['error']['lessthan3'];
        exit();
    } elseif (ereg("^-|-$", $_POST['domainForm'])){
        echo $message['error']['hyphens'];
        exit();
    } elseif (!ereg("([a-z]|[A-Z]|[0-9]|-){".strlen($_POST['domainForm'])."}", $_POST['domainForm'])){
        echo $message['error']['characters'];
        exit();
    } else {

        /* Domain Details for Whois checks */
        if (file_exists('queries.inc.php')){
            require_once('queries.inc.php');
        } else {
            exit($message['error']['no_query_file']);
        }

        /* Do the Whois */
        $domain = $_POST['domainForm'].'.'.$_POST['extForm'];
        $ns = fsockopen($server, 43); fputs($ns, "$domain\r\n");
        $result = '';
        while(!feof($ns)) $result .= fgets($ns, 128); fclose($ns);
            if (eregi($error, $result)){
                // Domain is available.
                if ($config['domain']['purchase_url'] != ''){
                $output = str_replace('{DOMAIN}', $domain, $config['domain']['available_text']);
                $output .= str_replace('{DOMAIN}', $domain, $config['domain']['purchase_text']);
            } else {
                 $output = str_replace('{DOMAIN}', $domain, $config['domain']['available_text']);
            }
            echo $output;
            } else {
                // Domain is unavailable.
                if ($config['domain']['whois_results'] == 1){
                    $output = str_replace('{DOMAIN}', $domain, $config['domain']['unavailable_text']);
                    echo $output;
                    echo '<pre>';
                    $fp = fsockopen($server, 43);
                    fputs($fp, "$domain\r\n");
                    while(!feof($fp)){
                        echo fgets($fp, 128);
                    }
                    fclose($fp);
                    echo '</pre>';

                } else {
                    $output = str_replace('{DOMAIN}', $domain, $config['domain']['unavailable_text']);
                    echo $output;
                }
            }
            /* Write to log file. */
            if ($config['domain']['log_whois'] == 1){
            whoisLog($domain);
            }
        }
    }
}

?>