-- phpMyAdmin SQL Dump
-- version 2.11.9.2
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Nov 05, 2011 at 08:06 PM
-- Server version: 5.0.67
-- PHP Version: 5.2.6

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `tpp`
--

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_banned`
--

CREATE TABLE IF NOT EXISTS `tpersia1_banned` (
  `id` smallint(5) NOT NULL auto_increment,
  `users_id` mediumint(8) NOT NULL default '0',
  `descr` text NOT NULL,
  `date` varchar(15) NOT NULL default '',
  `days` smallint(4) NOT NULL default '0',
  `ip` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `user_id` (`users_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_banned`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_banners`
--

CREATE TABLE IF NOT EXISTS `tpersia1_banners` (
  `id` smallint(5) NOT NULL auto_increment,
  `banner_tag` varchar(40) NOT NULL default '',
  `descr` varchar(200) NOT NULL default '',
  `code` text NOT NULL,
  `approve` tinyint(1) NOT NULL default '0',
  `short_place` tinyint(1) NOT NULL default '0',
  `bstick` tinyint(1) NOT NULL default '0',
  `main` tinyint(1) NOT NULL default '0',
  `category` varchar(255) NOT NULL default '',
  `grouplevel` varchar(100) NOT NULL default 'all',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_banners`
--

INSERT INTO `tpersia1_banners` (`id`, `banner_tag`, `descr`, `code`, `approve`, `short_place`, `bstick`, `main`, `category`, `grouplevel`) VALUES
(1, 'header', 'tpersia', '<div align="CENTER"><a href="http://Tpersia.com/" target="_blank"><img src="logos/banner.png" style="border: none;" /></a></div>', 1, 0, 0, 0, '0', 'all');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_category`
--

CREATE TABLE IF NOT EXISTS `tpersia1_category` (
  `id` smallint(5) NOT NULL auto_increment,
  `parentid` smallint(5) NOT NULL default '0',
  `posi` smallint(5) NOT NULL default '1',
  `name` varchar(50) NOT NULL default '',
  `alt_name` varchar(50) NOT NULL default '',
  `icon` varchar(200) NOT NULL default '',
  `skin` varchar(50) NOT NULL default '',
  `descr` varchar(200) NOT NULL default '',
  `keywords` text NOT NULL,
  `news_sort` varchar(10) NOT NULL default '',
  `news_msort` varchar(4) NOT NULL default '',
  `news_number` smallint(5) NOT NULL default '0',
  `short_tpl` varchar(40) NOT NULL default '',
  `full_tpl` varchar(40) NOT NULL default '',
  `forum_id` smallint(5) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_category`
--

INSERT INTO `tpersia1_category` (`id`, `parentid`, `posi`, `name`, `alt_name`, `icon`, `skin`, `descr`, `keywords`, `news_sort`, `news_msort`, `news_number`, `short_tpl`, `full_tpl`, `forum_id`) VALUES
(1, 0, 1, '?????', 'main', '', '', '', '', '', '', 0, '', '', 0);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_comments`
--

CREATE TABLE IF NOT EXISTS `tpersia1_comments` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `post_id` int(11) NOT NULL default '0',
  `user_id` mediumint(8) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `autor` varchar(40) NOT NULL default '',
  `email` varchar(40) NOT NULL default '',
  `text` text NOT NULL,
  `ip` varchar(16) NOT NULL default '',
  `is_register` tinyint(1) NOT NULL default '0',
  `approve` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `user_id` (`user_id`),
  FULLTEXT KEY `text` (`text`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_comments`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_email`
--

CREATE TABLE IF NOT EXISTS `tpersia1_email` (
  `id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(10) NOT NULL default '',
  `template` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;

--
-- Dumping data for table `tpersia1_email`
--

INSERT INTO `tpersia1_email` (`id`, `name`, `template`) VALUES
(1, 'reg_mail', '{%username%},\r\n\r\nThis email has been sent from http://khiaboon.com/\r\n\r\nYou have received this email because this email address was used during registration for our website. If you did not register at our site, please disregard this email. You do not need to unsubscribe or take any further action.\r\n\r\n------------------------------------------------\r\nActivation Instructions\r\n------------------------------------------------\r\n\r\nThank you for registering. We require that you validate your registration to ensure that the email address you entered was correct. This protects against unwanted spam and malicious abuse.\r\n\r\nTo activate your account, simply click on the following link:\r\n\r\n{%validationlink%}\r\n\r\nIf you cannot validate your account, its possible that the account has been removed. If this is the case, please contact an administrator to rectify the problem.\r\n\r\nRegards,\r\n\r\nAdministration http://khiaboon.com/.'),
(2, 'feed_mail', 'Dear {%username_to%},\r\n\r\nThis is regarding the feedback form sent from user {%username_from%} at our site http://khiaboon.com/\r\n\r\n------------------------------------------------\r\nYour message\r\n------------------------------------------------\r\n\r\n{%text%}\r\n\r\n\r\n------------------------------------------------\r\nThanks for the feedback. We take your comments and suggestions very seriously.\r\n\r\nRegards,\r\n\r\nAdministration http://khiaboon.com/'),
(3, 'lost_mail', 'Dear {%username%},\r\n\r\nIn regards to your password request, we must inform you we are unable to restore your current password, as it is stored encoded, and is not possible to restore it. We advise you visit the following link to obtain a new password:  \r\n\r\n{%lostlink%}\r\n\r\nIf you did not request this letter from our site, please disregard it.\r\n\r\nThankyou,\r\n\r\nAdministration http://khiaboon.com/'),
(4, 'new_news', 'New News in your site,\r\n\r\n Address: http://khiaboon.com/ \r\n\r\n------------------------------------------------\r\n \n------------------------------------------------\r\n\r\n Username: {%username%}\r\n Title: {%title%}\r\n Category: {%category%}\r\n Date: {%date%}\r\n\r\n ,\r\n\r\n Url: http://khiaboon.com/'),
(5, 'comments', 'New Comment in your site,\r\n\r\n Address: http://khiaboon.com/  \r\n\r\n------------------------------------------------\r\n r\n------------------------------------------------\r\n\r\nUserName: {%username%}\r\nDate: {%date%}\rS Site Url: {%link%}\r\nIP: {%ip%}\r\n\r\n------------------------------------------------\r\n r\n------------------------------------------------\r\n\r\n{%text%}\r\n\r\n,\r\n\r\n Url: http://khiaboon.com/'),
(6, 'pm', 'Dear {%username%},\r\n\r\n You have recived new pm in http://khiaboon.com/  .\r\n\r\n------------------------------------------------\r\n \r\n------------------------------------------------\r\n\r\n From: {%fromusername%}\r\n Date: {%date%}\r\n Title: {%title%}\r\n\r\n------------------------------------------------\r\n \r\n------------------------------------------------\r\n\r\n{%text%}\r\n\r\n,\r\n\r\n http://khiaboon.com/');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_files`
--

CREATE TABLE IF NOT EXISTS `tpersia1_files` (
  `id` mediumint(8) NOT NULL auto_increment,
  `news_id` int(10) NOT NULL default '0',
  `name` varchar(250) NOT NULL default '',
  `onserver` varchar(250) NOT NULL default '',
  `author` varchar(40) NOT NULL default '',
  `date` varchar(15) NOT NULL default '',
  `dcount` smallint(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_files`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_flood`
--

CREATE TABLE IF NOT EXISTS `tpersia1_flood` (
  `f_id` int(11) unsigned NOT NULL auto_increment,
  `ip` varchar(16) NOT NULL default '',
  `id` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`f_id`),
  KEY `ip` (`ip`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_flood`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_category`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_category` (
  `sid` int(11) NOT NULL auto_increment,
  `cat_name` varchar(128) NOT NULL default '',
  `posi` tinyint(3) NOT NULL default '0',
  KEY `sid` (`sid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_forum_category`
--

INSERT INTO `tpersia1_forum_category` (`sid`, `cat_name`, `posi`) VALUES
(1, 'Test Category', 1);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_email`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_email` (
  `id` int(11) NOT NULL default '0',
  `name` varchar(40) NOT NULL default '',
  `template` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `tpersia1_forum_email`
--

INSERT INTO `tpersia1_forum_email` (`id`, `name`, `template`) VALUES
(1, 'subscription_text', 'Hello, {%username_to%}!\r\n\r\n{%username_from%} responded to the topic "{%topic_name%}", '),
(2, 'frend_text', '{%username_to%},\r\n\r\nThe letter you sent {%username_from%} from http://khiaboon.com/\r\n\r\n------------------------------------------------\r\nYour message\r\n------------------------------------------------\r\n\r\n{%text%}\r\n\r\n------------------------------------------------\r\nKeep in mind that the administration of the site is not responsible for the content of the letter\r\n\r\nBest regards,\r\n\r\nAdministration http://khiaboon.com/'),
(3, 'report_text', 'This complaint you sent {%username_from%} from http://khiaboon.com/\r\n\r\n------------------------------------------------\r\nThe text of the complaint\r\n------------------------------------------------\r\n\r\n{%text%}\r\n\r\n------------------------------------------------\r\nA summary of the complaint\r\n------------------------------------------------\r\n\r\nSubject: {%topic_link%}\r\n\r\nID message: {%post_id%}\r\n\r\n------------------------------------------------\r\n\r\nBest regards,\r\n\r\nAdministration http://khiaboon.com/'),
(4, 'new_topic', 'Dear Administrator,\r\n\r\nadvised that the forum site was added to http://khiaboon.com/ issue.\r\n\r\n------------------------------------------------\r\nA summary of the topic\r\n------------------------------------------------\r\n\r\nBy: {%username%}\r\nDate: {%date%}\r\nThe title of the topic: {%title%}\r\nThe reference to the theme: {%link%}\r\n\r\n\r\nBest regards,\r\n\r\nAdministration http://khiaboon.com/');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_files`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_files` (
  `file_id` int(11) NOT NULL auto_increment,
  `file_type` varchar(10) NOT NULL default '',
  `forum_id` int(11) NOT NULL default '0',
  `topic_id` int(11) NOT NULL default '0',
  `post_id` int(11) NOT NULL default '0',
  `file_attach` tinyint(1) NOT NULL default '0',
  `file_name` varchar(250) NOT NULL default '',
  `onserver` varchar(250) NOT NULL default '',
  `file_author` varchar(40) NOT NULL default '',
  `file_date` int(10) NOT NULL default '0',
  `file_size` int(11) NOT NULL default '0',
  `dcount` int(11) NOT NULL default '0',
  PRIMARY KEY  (`file_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_forum_files`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_forums`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_forums` (
  `id` int(11) NOT NULL auto_increment,
  `parentid` int(11) NOT NULL default '0',
  `main_id` int(11) NOT NULL default '0',
  `topics` mediumint(6) NOT NULL default '0',
  `posts` mediumint(6) NOT NULL default '0',
  `name` varchar(128) NOT NULL default '',
  `description` text NOT NULL,
  `position` tinyint(3) NOT NULL default '0',
  `status` tinyint(1) NOT NULL default '1',
  `access_read` varchar(150) NOT NULL default '',
  `access_write` varchar(150) NOT NULL default '',
  `access_mod` varchar(150) NOT NULL default '',
  `access_topic` varchar(150) NOT NULL default '',
  `access_upload` varchar(150) NOT NULL default '',
  `access_download` varchar(150) NOT NULL default '',
  `f_last_tid` smallint(5) NOT NULL default '0',
  `f_last_title` varchar(150) NOT NULL default '',
  `f_last_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `f_last_poster_name` varchar(40) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `rules_title` varchar(128) NOT NULL default '',
  `rules` text NOT NULL,
  `icon` varchar(40) NOT NULL default '',
  `moderators` varchar(150) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_forum_forums`
--

INSERT INTO `tpersia1_forum_forums` (`id`, `parentid`, `main_id`, `topics`, `posts`, `name`, `description`, `position`, `status`, `access_read`, `access_write`, `access_mod`, `access_topic`, `access_upload`, `access_download`, `f_last_tid`, `f_last_title`, `f_last_date`, `f_last_poster_name`, `password`, `rules_title`, `rules`, `icon`, `moderators`) VALUES
(1, 0, 1, 1, 0, 'Test Forum', 'Test forum may be removed at any time', 1, 1, '1:2:3:4:5', '1:2:3:4', '1', '1', '1', '1:2:3:4', 1, 'Welcome', '0000-00-00 00:00:00', 'Arash.N', '', '', '', '', '');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_groups`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_groups` (
  `group_id` int(11) NOT NULL default '0',
  `group_colour` varchar(40) NOT NULL default '',
  `offline` tinyint(1) NOT NULL default '0',
  `post_edit` tinyint(1) NOT NULL default '0',
  `post_del` tinyint(1) NOT NULL default '0',
  `topic_set` tinyint(1) NOT NULL default '0',
  `topic_edit` tinyint(1) NOT NULL default '0',
  `topic_del` tinyint(1) NOT NULL default '0',
  `vote` tinyint(1) NOT NULL default '0',
  `flood` char(1) NOT NULL default '0',
  `html` tinyint(1) NOT NULL default '0',
  `filter` tinyint(1) NOT NULL default '0',
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `tpersia1_forum_groups`
--

INSERT INTO `tpersia1_forum_groups` (`group_id`, `group_colour`, `offline`, `post_edit`, `post_del`, `topic_set`, `topic_edit`, `topic_del`, `vote`, `flood`, `html`, `filter`) VALUES
(1, 'red', 1, 1, 1, 1, 1, 1, 1, '0', 0, 0),
(2, 'blue', 0, 1, 1, 1, 1, 1, 1, '0', 0, 0),
(3, '', 0, 1, 1, 1, 0, 0, 1, '1', 0, 1),
(4, '', 0, 1, 1, 0, 0, 0, 1, '1', 0, 1),
(5, '', 0, 0, 0, 0, 0, 0, 0, '0', 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_moderators`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_moderators` (
  `mid` mediumint(8) NOT NULL auto_increment,
  `forum_id` int(11) NOT NULL default '0',
  `member_name` varchar(32) NOT NULL default '',
  `member_id` mediumint(8) NOT NULL default '0',
  `edit_post` tinyint(1) default NULL,
  `edit_topic` tinyint(1) default NULL,
  `delete_post` tinyint(1) default NULL,
  `delete_topic` tinyint(1) default NULL,
  `open_topic` tinyint(1) NOT NULL default '0',
  `close_topic` tinyint(1) default NULL,
  `mass_prune` tinyint(1) default NULL,
  `move_topic` tinyint(1) default NULL,
  `pin_topic` tinyint(1) default NULL,
  `unpin_topic` tinyint(1) default NULL,
  `allow_warn` tinyint(1) default NULL,
  `is_group` tinyint(1) default '0',
  `group_id` smallint(3) default NULL,
  PRIMARY KEY  (`mid`),
  KEY `forum_id` (`forum_id`),
  KEY `group_id` (`group_id`),
  KEY `member_id` (`member_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=6 ;

--
-- Dumping data for table `tpersia1_forum_moderators`
--

INSERT INTO `tpersia1_forum_moderators` (`mid`, `forum_id`, `member_name`, `member_id`, `edit_post`, `edit_topic`, `delete_post`, `delete_topic`, `open_topic`, `close_topic`, `mass_prune`, `move_topic`, `pin_topic`, `unpin_topic`, `allow_warn`, `is_group`, `group_id`) VALUES
(1, 0, '', 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1),
(2, 0, '', 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 2),
(3, 0, '', 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 3),
(4, 0, '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4),
(5, 0, '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_poll_log`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_poll_log` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `topic_id` int(10) unsigned NOT NULL default '0',
  `member` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`topic_id`,`member`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_forum_poll_log`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_posts`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_posts` (
  `pid` int(11) NOT NULL auto_increment,
  `topic_id` int(11) NOT NULL default '0',
  `post_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `post_author` varchar(40) NOT NULL default '',
  `post_text` text NOT NULL,
  `post_ip` varchar(16) NOT NULL default '',
  `is_register` tinyint(1) NOT NULL default '0',
  `e_mail` varchar(40) NOT NULL default '',
  `edit_user` varchar(40) NOT NULL default '0',
  `edit_time` int(10) NOT NULL default '0',
  `hidden` tinyint(1) NOT NULL default '0',
  `wysiwyg` tinyint(1) default '0',
  PRIMARY KEY  (`pid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_forum_posts`
--

INSERT INTO `tpersia1_forum_posts` (`pid`, `topic_id`, `post_date`, `post_author`, `post_text`, `post_ip`, `is_register`, `e_mail`, `edit_user`, `edit_time`, `hidden`, `wysiwyg`) VALUES
(1, 1, '2009-01-06 22:13:05', 'sina haghighi', 'Welcome to your new forum !<br /><br />tp<br><br><a href="http://tpersia.Com" target="_blank">tpersia</a><br><a href="http://English.Tpersia.com" target="_blank">English.Tpersia.com</a><br><a href="http://Tpersia.com" target="_blank">Tpersia.com</a>', '127.0.0.1', 1, '', '0', 0, 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_reputation_log`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_reputation_log` (
  `rid` int(11) NOT NULL auto_increment,
  `mid` varchar(8) NOT NULL default '0',
  `author` varchar(40) NOT NULL,
  `action` char(1) NOT NULL,
  `cause` text NOT NULL,
  `date` int(10) NOT NULL default '0',
  PRIMARY KEY  (`rid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_forum_reputation_log`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_sessions`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_sessions` (
  `id` varchar(60) NOT NULL default '0',
  `member_name` varchar(64) NOT NULL default '',
  `user_group` int(11) NOT NULL default '5',
  `member_id` mediumint(8) NOT NULL default '0',
  `ip` varchar(16) NOT NULL default '',
  `browser` varchar(200) NOT NULL default '',
  `running_time` int(10) NOT NULL default '0',
  `location` varchar(40) NOT NULL default '',
  `act_index` int(10) NOT NULL default '0',
  `act_forum` int(10) NOT NULL default '0',
  `act_topic` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `act_topic` (`act_topic`),
  KEY `act_forum` (`act_forum`),
  KEY `act_index` (`act_index`),
  KEY `running_time` (`running_time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `tpersia1_forum_sessions`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_subscription`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_subscription` (
  `sid` int(11) NOT NULL auto_increment,
  `user_id` mediumint(8) NOT NULL default '0',
  `topic_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_forum_subscription`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_titles`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_titles` (
  `id` int(11) NOT NULL auto_increment,
  `posts` int(11) NOT NULL default '0',
  `title` varchar(128) NOT NULL default '',
  `pips` varchar(128) NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

--
-- Dumping data for table `tpersia1_forum_titles`
--

INSERT INTO `tpersia1_forum_titles` (`id`, `posts`, `title`, `pips`) VALUES
(1, 0, '??? ????', '1'),
(2, 10, '??? ????', '2'),
(3, 30, '??? ???????', '3');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_topics`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_topics` (
  `tid` int(11) NOT NULL auto_increment,
  `forum_id` int(11) NOT NULL default '0',
  `title` varchar(70) NOT NULL default '',
  `topic_descr` varchar(70) NOT NULL default '',
  `icon` varchar(20) default '0',
  `post` int(11) NOT NULL default '0',
  `views` int(11) NOT NULL default '0',
  `author_topic` varchar(40) NOT NULL default '',
  `start_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_poster_name` varchar(40) NOT NULL default '',
  `topic_status` int(1) NOT NULL default '0',
  `hidden` int(1) NOT NULL default '0',
  `fixed` int(1) NOT NULL default '1',
  `poll_title` varchar(200) NOT NULL default '',
  `frage` varchar(200) NOT NULL default '',
  `poll_body` text NOT NULL,
  `poll_count` mediumint(8) NOT NULL default '0',
  `answer` varchar(150) NOT NULL default '',
  `multiple` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`tid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_forum_topics`
--

INSERT INTO `tpersia1_forum_topics` (`tid`, `forum_id`, `title`, `topic_descr`, `icon`, `post`, `views`, `author_topic`, `start_date`, `last_date`, `last_poster_name`, `topic_status`, `hidden`, `fixed`, `poll_title`, `frage`, `poll_body`, `poll_count`, `answer`, `multiple`) VALUES
(1, 1, 'Welcome', '', 'icon13', 0, 0, 'Mohammad_1ta', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'Mohammad_1ta', 0, 0, 1, '', '', '', 0, '', 0);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_views`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_views` (
  `topic_id` int(11) NOT NULL default '0',
  `forum_id` int(11) NOT NULL default '0',
  `user_id` mediumint(8) NOT NULL default '0',
  `time` int(11) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `tpersia1_forum_views`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_forum_warn_log`
--

CREATE TABLE IF NOT EXISTS `tpersia1_forum_warn_log` (
  `wid` int(11) NOT NULL auto_increment,
  `mid` varchar(8) NOT NULL default '0',
  `author` varchar(40) NOT NULL,
  `action` char(1) NOT NULL,
  `cause` text NOT NULL,
  `date` int(10) NOT NULL default '0',
  PRIMARY KEY  (`wid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_forum_warn_log`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_images`
--

CREATE TABLE IF NOT EXISTS `tpersia1_images` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `images` text NOT NULL,
  `news_id` int(10) NOT NULL default '0',
  `author` varchar(40) NOT NULL default '',
  `date` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `author` (`author`),
  KEY `news_id` (`news_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_images`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_logs`
--

CREATE TABLE IF NOT EXISTS `tpersia1_logs` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `news_id` int(10) NOT NULL default '0',
  `member` varchar(40) NOT NULL default '',
  `ip` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`),
  KEY `member` (`member`),
  KEY `ip` (`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_logs`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_lostdb`
--

CREATE TABLE IF NOT EXISTS `tpersia1_lostdb` (
  `id` mediumint(8) NOT NULL auto_increment,
  `lostname` mediumint(8) NOT NULL default '0',
  `lostid` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `lostid` (`lostid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_lostdb`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_notice`
--

CREATE TABLE IF NOT EXISTS `tpersia1_notice` (
  `id` mediumint(8) NOT NULL auto_increment,
  `user_id` mediumint(8) NOT NULL default '0',
  `notice` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_notice`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_obmen`
--

CREATE TABLE IF NOT EXISTS `tpersia1_obmen` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `link` varchar(255) NOT NULL default '',
  `icq` varchar(255) NOT NULL default '',
  `mail` varchar(255) NOT NULL default '',
  `posit` smallint(5) NOT NULL default '1',
  `description` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_obmen`
--

INSERT INTO `tpersia1_obmen` (`id`, `title`, `link`, `icq`, `mail`, `posit`, `description`) VALUES
(1, 'TPersia site manager 2', 'http://Tpersia.com', '', 'sina.h39@gmail.com', 0, 'TPersia site manager 2');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_online`
--

CREATE TABLE IF NOT EXISTS `tpersia1_online` (
  `uid` mediumint(8) unsigned NOT NULL default '0',
  `username` varchar(30) NOT NULL default '',
  `time` datetime default NULL,
  `ip` tinytext,
  `about` text NOT NULL,
  `country` text,
  KEY `idx` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `tpersia1_online`
--

INSERT INTO `tpersia1_online` (`uid`, `username`, `time`, `ip`, `about`, `country`) VALUES
(0, '', '2011-11-05 23:19:25', '127.0.0.1', 'Unknown|Firefox||ميهمان|', '-'),
(0, '', '2011-11-05 23:19:38', '127.0.0.1', 'Unknown|Firefox||ميهمان|', '-'),
(0, '', '2011-11-05 23:20:45', '127.0.0.1', 'Unknown|Firefox||ميهمان|', '-'),
(1, 'admin', '2011-11-05 23:21:24', '127.0.0.1', 'Unknown|Firefox||مدير سايت|', '-'),
(1, 'admin', '2011-11-05 23:25:37', '127.0.0.1', 'Unknown|Firefox||مدير سايت|', '-'),
(1, 'admin', '2011-11-05 23:29:11', '127.0.0.1', 'Unknown|Firefox||مدير سايت|', '-'),
(1, 'admin', '2011-11-05 23:30:21', '127.0.0.1', 'Unknown|Firefox||مدير سايت|', '-'),
(1, 'admin', '2011-11-05 23:32:35', '127.0.0.1', 'Unknown|Firefox||مدير سايت|', '-');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_pm`
--

CREATE TABLE IF NOT EXISTS `tpersia1_pm` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `subj` varchar(255) NOT NULL default '',
  `text` text NOT NULL,
  `user` mediumint(8) NOT NULL default '0',
  `user_from` varchar(50) NOT NULL default '',
  `date` varchar(15) NOT NULL default '',
  `pm_read` char(3) NOT NULL default '',
  `folder` varchar(10) NOT NULL default '',
  `reply` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `folder` (`folder`),
  KEY `user` (`user`),
  KEY `user_from` (`user_from`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_pm`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_poll`
--

CREATE TABLE IF NOT EXISTS `tpersia1_poll` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `news_id` int(10) unsigned NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `frage` varchar(200) NOT NULL default '',
  `body` text NOT NULL,
  `votes` mediumint(8) NOT NULL default '0',
  `multiple` tinyint(1) NOT NULL default '0',
  `answer` varchar(150) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_poll`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_poll_log`
--

CREATE TABLE IF NOT EXISTS `tpersia1_poll_log` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `news_id` int(10) unsigned NOT NULL default '0',
  `member` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`,`member`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_poll_log`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_post`
--

CREATE TABLE IF NOT EXISTS `tpersia1_post` (
  `id` int(11) NOT NULL auto_increment,
  `autor` varchar(40) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `short_story` text NOT NULL,
  `full_story` text NOT NULL,
  `xfields` text NOT NULL,
  `title` varchar(255) NOT NULL default '',
  `descr` varchar(200) NOT NULL default '',
  `keywords` text NOT NULL,
  `category` varchar(200) NOT NULL default '0',
  `alt_name` varchar(200) NOT NULL default '',
  `comm_num` smallint(5) unsigned NOT NULL default '0',
  `allow_comm` tinyint(1) NOT NULL default '1',
  `allow_main` tinyint(1) unsigned NOT NULL default '1',
  `allow_rate` tinyint(1) unsigned NOT NULL default '1',
  `approve` tinyint(1) NOT NULL default '0',
  `fixed` tinyint(1) NOT NULL default '0',
  `rating` smallint(5) NOT NULL default '0',
  `allow_br` tinyint(1) NOT NULL default '1',
  `vote_num` smallint(5) unsigned NOT NULL default '0',
  `news_read` mediumint(8) unsigned NOT NULL default '0',
  `votes` tinyint(1) NOT NULL default '0',
  `access` varchar(150) NOT NULL default '',
  `expires` date NOT NULL default '0000-00-00',
  `symbol` varchar(3) NOT NULL default '',
  `flag` tinyint(1) NOT NULL default '1',
  `editdate` varchar(15) NOT NULL default '',
  `editor` varchar(40) NOT NULL default '',
  `reason` varchar(255) NOT NULL default '',
  `view_edit` tinyint(1) NOT NULL default '0',
  `tags` varchar(255) NOT NULL default '',
  `news_tid` smallint(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `autor` (`autor`),
  KEY `alt_name` (`alt_name`),
  KEY `category` (`category`),
  KEY `approve` (`approve`),
  KEY `allow_main` (`allow_main`),
  KEY `date` (`date`),
  KEY `symbol` (`symbol`),
  KEY `comm_num` (`comm_num`),
  KEY `tags` (`tags`),
  FULLTEXT KEY `short_story` (`short_story`,`full_story`,`xfields`,`title`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_post`
--

INSERT INTO `tpersia1_post` (`id`, `autor`, `date`, `short_story`, `full_story`, `xfields`, `title`, `descr`, `keywords`, `category`, `alt_name`, `comm_num`, `allow_comm`, `allow_main`, `allow_rate`, `approve`, `fixed`, `rating`, `allow_br`, `vote_num`, `news_read`, `votes`, `access`, `expires`, `symbol`, `flag`, `editdate`, `editor`, `reason`, `view_edit`, `tags`, `news_tid`) VALUES
(1, 'khiaboon', '2011-09-07 19:07:37', 'سیستم مدیریت محتوا و سایت ساز تی پی پنل نال شده <br /><br />نال شده توسط <a href="http://tiny.cc/tppanel" target="_blank">گروه پی سی ول</a><br /><br /><div align="center"><!--sizestart:3--><span style="font-size:12pt;line-height:100%"><!--/sizestart-->پی سی ول اولین مرجع اسکریپت های رایگان و نال شده<!--sizeend--></span><!--/sizeend--></div>', '', '', 'پی سی ول', 'سیستم مدیریت محتوا و سایت ساز تی پی پنل نال شده   نال شده توسط گروه پی سی ول  www.p30vel.ir', 'نال, شده, توسط, گروه, wwwp30velir, پنل, مدیریت, محتوا, سایت, ساز, سیستم', '1', 'post1', 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, '', '0000-00-00', '', 1, '1320523438', 'admin', '', 0, 'p30vel.ir', 0);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_rss`
--

CREATE TABLE IF NOT EXISTS `tpersia1_rss` (
  `id` smallint(5) NOT NULL auto_increment,
  `url` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `allow_main` tinyint(1) NOT NULL default '0',
  `allow_rating` tinyint(1) NOT NULL default '0',
  `allow_comm` tinyint(1) NOT NULL default '0',
  `text_type` tinyint(1) NOT NULL default '0',
  `date` tinyint(1) NOT NULL default '0',
  `search` text NOT NULL,
  `max_news` tinyint(3) NOT NULL default '0',
  `cookie` text NOT NULL,
  `category` smallint(5) NOT NULL default '0',
  `lastdate` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_rss`
--

INSERT INTO `tpersia1_rss` (`id`, `url`, `description`, `allow_main`, `allow_rating`, `allow_comm`, `text_type`, `date`, `search`, `max_news`, `cookie`, `category`, `lastdate`) VALUES
(1, 'http://Tpersia.com/rss.xml', 'Tpersia.com', 1, 1, 1, 1, 1, '<div id=''news-id-{skip}''>{get}</div></td>', 5, '', 1, '');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_rssinform`
--

CREATE TABLE IF NOT EXISTS `tpersia1_rssinform` (
  `id` smallint(5) NOT NULL auto_increment,
  `tag` varchar(40) NOT NULL default '',
  `descr` varchar(255) NOT NULL default '',
  `category` varchar(200) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `template` varchar(40) NOT NULL default '',
  `news_max` smallint(5) NOT NULL default '0',
  `tmax` smallint(5) NOT NULL default '0',
  `dmax` smallint(5) NOT NULL default '0',
  `approve` tinyint(1) NOT NULL default '1',
  `rss_date_format` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_rssinform`
--

INSERT INTO `tpersia1_rssinform` (`id`, `tag`, `descr`, `category`, `url`, `template`, `news_max`, `tmax`, `dmax`, `approve`, `rss_date_format`) VALUES
(1, 'tp', ' ?? ?????', '0', 'http://Tpersia.com/engine/rss.xml', 'informer', 3, 0, 200, 1, 'j F Y H:i');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_static`
--

CREATE TABLE IF NOT EXISTS `tpersia1_static` (
  `id` mediumint(8) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `descr` varchar(255) NOT NULL default '',
  `template` text NOT NULL,
  `allow_br` tinyint(1) NOT NULL default '0',
  `allow_template` tinyint(1) NOT NULL default '0',
  `grouplevel` varchar(100) NOT NULL default 'all',
  `tpl` varchar(40) NOT NULL default '',
  `metadescr` varchar(200) NOT NULL default '',
  `metakeys` text NOT NULL,
  `views` mediumint(8) NOT NULL default '0',
  `template_folder` varchar(50) NOT NULL default '',
  `date` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`),
  FULLTEXT KEY `template` (`template`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_static`
--

INSERT INTO `tpersia1_static` (`id`, `name`, `descr`, `template`, `allow_br`, `allow_template`, `grouplevel`, `tpl`, `metadescr`, `metakeys`, `views`, `template_folder`, `date`) VALUES
(1, 'dle-rules-page', '?????? ????', '???? ?????? ?? ?? ?????? ????? ?????? ????.<BR><BR> \r\n{ACCEPT-DECLINE}', 1, 1, 'all', '', 'Rulles', 'Rulles', 0, '', '');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_static_files`
--

CREATE TABLE IF NOT EXISTS `tpersia1_static_files` (
  `id` mediumint(8) NOT NULL auto_increment,
  `static_id` mediumint(8) NOT NULL default '0',
  `author` varchar(40) NOT NULL default '',
  `date` varchar(50) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `onserver` varchar(255) NOT NULL default '',
  `dcount` smallint(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `static_id` (`static_id`),
  KEY `onserver` (`onserver`),
  KEY `author` (`author`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_static_files`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_tags`
--

CREATE TABLE IF NOT EXISTS `tpersia1_tags` (
  `id` int(11) NOT NULL auto_increment,
  `news_id` int(11) NOT NULL default '0',
  `tag` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`),
  KEY `tag` (`tag`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;

--
-- Dumping data for table `tpersia1_tags`
--

INSERT INTO `tpersia1_tags` (`id`, `news_id`, `tag`) VALUES
(1, 1, 'DLE'),
(2, 1, 'tpersia'),
(3, 1, 't'),
(4, 1, 'p'),
(5, 1, 'iran'),
(6, 1, 'Persian'),
(7, 1, 'Tpersia.com');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_usergroups`
--

CREATE TABLE IF NOT EXISTS `tpersia1_usergroups` (
  `id` smallint(5) NOT NULL auto_increment,
  `group_name` varchar(32) NOT NULL default '',
  `allow_cats` text NOT NULL,
  `allow_adds` tinyint(1) NOT NULL default '1',
  `cat_add` text NOT NULL,
  `allow_admin` tinyint(1) NOT NULL default '0',
  `allow_addc` tinyint(1) NOT NULL default '0',
  `allow_editc` tinyint(1) NOT NULL default '0',
  `allow_delc` tinyint(1) NOT NULL default '0',
  `edit_allc` tinyint(1) NOT NULL default '0',
  `del_allc` tinyint(1) NOT NULL default '0',
  `moderation` tinyint(1) NOT NULL default '0',
  `allow_all_edit` tinyint(1) NOT NULL default '0',
  `allow_edit` tinyint(1) NOT NULL default '0',
  `allow_pm` tinyint(1) NOT NULL default '0',
  `max_pm` smallint(5) NOT NULL default '0',
  `max_foto` smallint(5) NOT NULL default '0',
  `allow_files` tinyint(1) NOT NULL default '1',
  `allow_hide` tinyint(1) NOT NULL default '1',
  `allow_short` tinyint(1) NOT NULL default '0',
  `time_limit` tinyint(1) NOT NULL default '0',
  `rid` smallint(5) NOT NULL default '0',
  `allow_fixed` tinyint(1) NOT NULL default '0',
  `allow_feed` tinyint(1) NOT NULL default '1',
  `allow_search` tinyint(1) NOT NULL default '1',
  `allow_poll` tinyint(1) NOT NULL default '1',
  `allow_main` tinyint(1) NOT NULL default '1',
  `captcha` tinyint(1) NOT NULL default '0',
  `icon` varchar(200) NOT NULL default '',
  `allow_modc` tinyint(1) NOT NULL default '0',
  `allow_rating` tinyint(1) NOT NULL default '1',
  `allow_offline` tinyint(1) NOT NULL default '0',
  `allow_image_upload` tinyint(1) NOT NULL default '0',
  `allow_file_upload` tinyint(1) NOT NULL default '0',
  `allow_signature` tinyint(1) NOT NULL default '0',
  `allow_url` tinyint(1) NOT NULL default '1',
  `news_sec_code` tinyint(1) NOT NULL default '1',
  `allow_image` tinyint(1) NOT NULL default '0',
  `max_signature` smallint(6) NOT NULL default '0',
  `max_info` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=6 ;

--
-- Dumping data for table `tpersia1_usergroups`
--

INSERT INTO `tpersia1_usergroups` (`id`, `group_name`, `allow_cats`, `allow_adds`, `cat_add`, `allow_admin`, `allow_addc`, `allow_editc`, `allow_delc`, `edit_allc`, `del_allc`, `moderation`, `allow_all_edit`, `allow_edit`, `allow_pm`, `max_pm`, `max_foto`, `allow_files`, `allow_hide`, `allow_short`, `time_limit`, `rid`, `allow_fixed`, `allow_feed`, `allow_search`, `allow_poll`, `allow_main`, `captcha`, `icon`, `allow_modc`, `allow_rating`, `allow_offline`, `allow_image_upload`, `allow_file_upload`, `allow_signature`, `allow_url`, `news_sec_code`, `allow_image`, `max_signature`, `max_info`) VALUES
(1, '???? ????', 'all', 1, 'all', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 50, 101, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, '{THEME}/images/icon_1.gif', 0, 1, 1, 1, 1, 1, 1, 0, 1, 500, 1000),
(2, '????', 'all', 1, 'all', 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 50, 101, 1, 1, 1, 0, 2, 1, 1, 1, 1, 1, 0, '{THEME}/images/icon_2.gif', 0, 1, 0, 1, 1, 1, 1, 0, 1, 500, 1000),
(3, '???????? ?????', 'all', 1, 'all', 1, 1, 1, 1, 0, 0, 1, 0, 1, 1, 50, 101, 1, 1, 1, 0, 3, 0, 1, 1, 1, 1, 0, '{THEME}/images/icon_3.gif', 0, 1, 0, 1, 1, 1, 1, 0, 1, 500, 1000),
(4, '??? ????', 'all', 1, 'all', 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 20, 101, 1, 1, 1, 0, 4, 0, 1, 1, 1, 1, 0, '{THEME}/images/icon_4.gif', 0, 1, 0, 1, 1, 1, 1, 1, 0, 500, 1000),
(5, '??????', 'all', 0, 'all', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 5, 0, 1, 1, 1, 0, 1, '{THEME}/images/icon_5.gif', 0, 1, 0, 0, 0, 0, 1, 1, 0, 1, 1);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_users`
--

CREATE TABLE IF NOT EXISTS `tpersia1_users` (
  `email` varchar(50) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `name` varchar(40) NOT NULL default '',
  `user_id` mediumint(8) NOT NULL auto_increment,
  `news_num` smallint(6) NOT NULL default '0',
  `comm_num` mediumint(8) NOT NULL default '0',
  `user_group` smallint(5) NOT NULL default '4',
  `lastdate` varchar(20) default NULL,
  `reg_date` varchar(20) default NULL,
  `banned` varchar(5) NOT NULL default '',
  `allow_mail` tinyint(1) NOT NULL default '1',
  `info` text NOT NULL,
  `signature` text NOT NULL,
  `foto` varchar(30) NOT NULL default '',
  `fullname` varchar(100) NOT NULL default '',
  `land` varchar(100) NOT NULL default '',
  `icq` varchar(20) NOT NULL default '',
  `favorites` text NOT NULL,
  `pm_all` smallint(5) NOT NULL default '0',
  `pm_unread` smallint(5) NOT NULL default '0',
  `time_limit` varchar(20) NOT NULL default '',
  `xfields` text NOT NULL,
  `allowed_ip` varchar(255) NOT NULL default '',
  `hash` varchar(32) NOT NULL default '',
  `logged_ip` varchar(16) NOT NULL default '',
  `restricted` tinyint(1) NOT NULL default '0',
  `restricted_days` smallint(4) NOT NULL default '0',
  `restricted_date` varchar(15) NOT NULL default '',
  `forum_post` smallint(5) NOT NULL default '0',
  `forum_warn` smallint(5) NOT NULL default '0',
  `forum_update` varchar(20) NOT NULL default '0',
  `forum_rank` varchar(40) NOT NULL default '0',
  `forum_pips` smallint(2) NOT NULL default '0',
  `forum_reputation` smallint(5) NOT NULL default '0',
  `forum_last` varchar(20) NOT NULL default '0',
  `forum_time` varchar(20) NOT NULL default '0',
  PRIMARY KEY  (`user_id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `email` (`email`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_users`
--

INSERT INTO `tpersia1_users` (`email`, `password`, `name`, `user_id`, `news_num`, `comm_num`, `user_group`, `lastdate`, `reg_date`, `banned`, `allow_mail`, `info`, `signature`, `foto`, `fullname`, `land`, `icq`, `favorites`, `pm_all`, `pm_unread`, `time_limit`, `xfields`, `allowed_ip`, `hash`, `logged_ip`, `restricted`, `restricted_days`, `restricted_date`, `forum_post`, `forum_warn`, `forum_update`, `forum_rank`, `forum_pips`, `forum_reputation`, `forum_last`, `forum_time`) VALUES
('support@p30vel.ir', '9433cc3ef69b4ad152013450fbd432be', 'admin', 1, 1, 0, 1, '1320522704', '1315406257', '', 1, '', '', '', '', '', '', '', 0, 0, '', '', '', '', '127.0.0.1', 0, 0, '', 0, 0, '0', '0', 0, 0, '0', '0');

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_views`
--

CREATE TABLE IF NOT EXISTS `tpersia1_views` (
  `id` mediumint(8) NOT NULL auto_increment,
  `news_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_views`
--


-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_vote`
--

CREATE TABLE IF NOT EXISTS `tpersia1_vote` (
  `id` mediumint(8) NOT NULL auto_increment,
  `category` varchar(200) NOT NULL default '',
  `vote_num` mediumint(8) NOT NULL default '0',
  `date` varchar(25) NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `body` text NOT NULL,
  `approve` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `category` (`category`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `tpersia1_vote`
--

INSERT INTO `tpersia1_vote` (`id`, `category`, `vote_num`, `date`, `title`, `body`, `approve`) VALUES
(1, 'all', 0, '2011-09-07 19:07:37', '?????? ?? ???? ???? ?', '????<br />???<br />?????<br />??', 1);

-- --------------------------------------------------------

--
-- Table structure for table `tpersia1_vote_result`
--

CREATE TABLE IF NOT EXISTS `tpersia1_vote_result` (
  `id` int(10) NOT NULL auto_increment,
  `ip` varchar(16) NOT NULL default '',
  `name` varchar(40) NOT NULL default '',
  `vote_id` mediumint(8) NOT NULL default '0',
  `answer` tinyint(3) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `answer` (`answer`),
  KEY `vote_id` (`vote_id`),
  KEY `ip` (`ip`),
  KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `tpersia1_vote_result`
--

